<template lang="pug">
  .select-panel
    .select-menu(
      @click="showMenu = !showMenu"
      ref="menuButton"
    ) {{ currentItem.title }}
      .icon(v-html="$icons.menuArrowDown")
      transition(name="scale-fade")
        .sub-menu(
          v-show="showMenu"
          ref="menu"
        )
          .sub-menu-row(
            v-for="item in items"
            :key="item.id"
            :class="{ active: item.id === currentItem.id }"
            @click="select(item)"
          )
            .link {{ item.title }}
    .checkSwappFotoContainer
      //- <input type="checkbox" class="checkSwappBox"  @change="select(items[3])">
      //- .checkSwappTxt Only swappable faces
      <input class="checkSwappBox" type="checkbox" id="checkbox" v-model="isSwappVar" @change="swappCheck"/>
      <label clas="checkSwappTxt" for="checkbox">Only swappable faces</label>
</template>

<script>
export default {
  name: 'SelectMenu',
  props: {
    currentItemId: {
      type: [String, Number],
      default: null
    },
    items: {
      type: Array,
      required: true
    }
  },
  data () {
    return {
      showMenu: false,
      currentItem: null,
      isSwappVar: false
    }
  },
  watch: {
    currentItemId () {
      this.currentItem = this.handleCurrentItem()
    }
  },
  created () {
    this.currentItem = this.handleCurrentItem()
  },
  mounted () {
    document.addEventListener('mousedown', this.outsideClick)
  },
  destroyed () {
    document.removeEventListener('mousedown', this.outsideClick)
  },
  methods: {
    handleCurrentItem () {
      return this.items.find(item => item.id === this.currentItemId) || this.items[0]
    },
    select (item) {
      this.currentItem = item
      this.$emit('select', item)
      // if(item !== this.items[3]){
      //   this.isSwappVar = false
      //   this.swappCheck()
      // }
    },
    outsideClick (event) {
      if (this.$refs.menu && this.$refs.menuButton && !this.$refs.menu.contains(event.target) && !this.$refs.menuButton.contains(event.target)) {
        this.showMenu = false
      }
    },
    swappCheck() {
      this.isSwappVar ? this.select(this.items[3]) : this.select(this.items[0])
    }
  }  
}
</script>

<style lang="scss" scoped>
@import '../assets/css/effects';

.select-menu {
  position: relative;
  display: flex;
  flex-direction: row;
  align-items: flex-end;
  font-size: 16px;
  font-weight: normal;
  text-transform: none;
  margin-right: 6px;
  cursor: pointer;

  .icon {
    width: 10px;
    height: 15px;
    fill: #8c8c8c;
    margin: 0 0 2px 10px;
  }

  .sub-menu {
    width: 88px;
    min-width: 88px;
    top: 28px;
    right: -4px;
    color: #fff;
    background-color: #2C2C2C;

    .link {
      justify-content: flex-end;
      padding-right: 24px;
    }
  }
}

.checkSwappFotoContainer {
    position: absolute;
    display: flex;
    left: 12px;
    transform: translateY(16px);
    align-items: center;
    margin-bottom: 16px;
    font-size: 14px;
    font-weight: 100;
    text-transform: none;

    .checkSwappBox{
      border: 1px solid rgba(255, 255, 255, 0.4);
      border-radius: 2px;
      margin-right: 10px;
    }

    .checkSwappTxt{
      font-size: 14px;
      line-height: 17px;
      margin-left: 7px;
    }

}

</style>
